function xdot = TeusinkModel(t,x,Etot)
% Teusink Kinetic Model For Yeast S. cerevisiae
%

       
GLCo =    50  ;              
GLY  =    0.15 ;             
ETOH =    50 ;               
CC14 = 1.59 - x(13); % NAD = 1.59 - NADH

% r1
VmGLT     =   97.264;    
KeqGLT    =   1;         
KmGLTGLCo =   1.1918;    
KmGLTGLCi =   1.1918;    
r1 = VmGLT*(GLCo-x(1)./KeqGLT)./(KmGLTGLCo*(1+GLCo./KmGLTGLCo+x(1)./KmGLTGLCi+0.91*GLCo.*x(1)./(KmGLTGLCi*KmGLTGLCo)));

% r2
VmGLK     =   226.452;    
SUMAXP    =   4.1 ;       
KeqAK     =   0.45;       
KeqGLK    =   3800 ;      
KmGLKATP  =   0.15 ;      
KmGLKGLCi =   0.08 ;      
KmGLKG6P  =   30   ;      
KmGLKADP  =   0.23 ;      
r2 = VmGLK*(-(x(2).*(SUMAXP-power(power(SUMAXP,2)-2*SUMAXP.*x(12)+8*KeqAK.*SUMAXP.*x(12)+power(x(12),2)-4*KeqAK.*power(x(12),2),0.5))./((1-4*KeqAK).*KeqGLK))+x(1).*(-SUMAXP+x(12)-4*KeqAK.*x(12)+power(power(SUMAXP,2)-2*SUMAXP*x(12)+8*KeqAK*SUMAXP.*x(12)+power(x(12),2)-4*KeqAK*power(x(12),2),0.5))./(2-8*KeqAK))./(KmGLKATP.*KmGLKGLCi.*(1+x(2)./KmGLKG6P+x(1)./KmGLKGLCi).*(1+(SUMAXP-power(power(SUMAXP,2)-2*SUMAXP.*x(12)+8*KeqAK.*SUMAXP.*x(12)+power(x(12),2)-4*KeqAK*power(x(12),2),0.5))./((1-4*KeqAK).*KmGLKADP)+(-SUMAXP+x(12)-4*KeqAK.*x(12)+power(power(SUMAXP,2)-2*SUMAXP.*x(12)+8*KeqAK*SUMAXP.*x(12)+power(x(12),2)-4*KeqAK.*power(x(12),2),0.5))./((2-8*KeqAK)*KmGLKATP)));

% r3
VmPGI     =  339.677;    
KmPGIG6P  =  1.4  ;      
KeqPGI    =  0.314;      
KmPGIF6P  =  0.3  ;      
r3 = VmPGI./KmPGIG6P.*(x(2)-x(3)./KeqPGI)./(1+x(2)./KmPGIG6P+x(3)./KmPGIF6P);

% r4
KGLYCOGEN =   6; 
r4 = KGLYCOGEN;

% r5
KTREHALOSE=    2.4;  
r5 = KTREHALOSE;


% r6
VmPFK    =    182.903 ;    
SUMAXP   =    4.1   ;      
KeqAK    =    0.45  ;      
KmPFKF6P =    0.1   ;      
KmPFKATP =    0.71  ;      
L0       =    0.66  ;      
CPFKF26BP=    0.0174;      
F26BP    =    0.02  ;      
KPFKF26BP=    0.000682 ;   
CPFKF16BP =   0.397 ;      
KPFKF16BP =   0.111 ;      
CPFKAMP   =   0.0845;      
KPFKAMP   =   0.0995;      
CiPFKATP  =   100   ;      
KiPFKATP  =   0.65  ;      
CPFKATP   =   3     ;
gR       =    5.12;
r6 = gR*VmPFK*x(3).*(-SUMAXP+x(12)-4*KeqAK.*x(12)+power(power(SUMAXP,2)-2*SUMAXP.*x(12)+8.*KeqAK.*SUMAXP.*x(12)+power(x(12),2)-4.*KeqAK.*power(x(12),2),0.5)).*(1+x(3)./KmPFKF6P+(-SUMAXP+x(12)-4.*KeqAK.*x(12)+power(power(SUMAXP,2)-2.*SUMAXP.*x(12)+8.*KeqAK.*SUMAXP.*x(12)+power(x(12),2)-4.*KeqAK.*power(x(12),2),0.5))./((2-8.*KeqAK).*KmPFKATP)+gR.*x(3).*(-SUMAXP+x(12)-4.*KeqAK.*x(12)+power(power(SUMAXP,2)-2.*SUMAXP.*x(12)+8.*KeqAK.*SUMAXP.*x(12)+power(x(12),2)-4.*KeqAK.*power(x(12),2),0.5))./((2-8.*KeqAK).*KmPFKATP.*KmPFKF6P))./((2-8.*KeqAK).*KmPFKATP.*KmPFKF6P.*(L0.*power(1+CPFKF26BP.*F26BP./KPFKF26BP+CPFKF16BP.*x(4)./KPFKF16BP,2).*power(1+2.*CPFKAMP.*KeqAK.*power(SUMAXP-power(power(SUMAXP,2)-2.*SUMAXP.*x(12)+8.*KeqAK.*SUMAXP.*x(12)+power(x(12),2)-4.*KeqAK.*power(x(12),2),0.5),2)./((-1+4.*KeqAK).*KPFKAMP.*(SUMAXP-x(12)+4.*KeqAK.*x(12)-power(power(SUMAXP,2)-2.*SUMAXP.*x(12)+8.*KeqAK.*SUMAXP.*x(12)+power(x(12),2)-4.*KeqAK.*power(x(12),2),0.5))),2).*power(1+CiPFKATP.*(-SUMAXP+x(12)-4.*KeqAK.*x(12)+power(power(SUMAXP,2)-2.*SUMAXP.*x(12)+8.*KeqAK.*SUMAXP.*x(12)+power(x(12),2)-4.*KeqAK.*power(x(12),2),0.5))./((2-8.*KeqAK).*KiPFKATP),2).*power(1+CPFKATP.*(-SUMAXP+x(12)-4.*KeqAK.*x(12)+power(power(SUMAXP,2)-2.*SUMAXP.*x(12)+8.*KeqAK.*SUMAXP.*x(12)+power(x(12),2)-4.*KeqAK.*power(x(12),2),0.5))./((2-8.*KeqAK).*KmPFKATP),2)./(power(1+F26BP./KPFKF26BP+x(4)./KPFKF16BP,2).*power(1+2.*KeqAK.*power(SUMAXP-power(power(SUMAXP,2)-2.*SUMAXP.*x(12)+8.*KeqAK.*SUMAXP.*x(12)+power(x(12),2)-4.*KeqAK.*power(x(12),2),0.5),2)./((-1+4.*KeqAK).*KPFKAMP.*(SUMAXP-x(12)+4.*KeqAK.*x(12)-power(power(SUMAXP,2)-2.*SUMAXP.*x(12)+8.*KeqAK.*SUMAXP.*x(12)+power(x(12),2)-4.*KeqAK.*power(x(12),2),0.5))),2).*power(1+(-SUMAXP+x(12)-4.*KeqAK.*x(12)+power(power(SUMAXP,2)-2.*SUMAXP.*x(12)+8.*KeqAK.*SUMAXP.*x(12)+power(x(12),2)-4.*KeqAK.*power(x(12),2),0.5))./((2-8.*KeqAK).*KiPFKATP),2))+power(1+x(3)./KmPFKF6P+(-SUMAXP+x(12)-4.*KeqAK.*x(12)+power(power(SUMAXP,2)-2.*SUMAXP.*x(12)+8.*KeqAK.*SUMAXP.*x(12)+power(x(12),2)-4.*KeqAK.*power(x(12),2),0.5))./((2-8.*KeqAK).*KmPFKATP)+gR.*x(3).*(-SUMAXP+x(12)-4.*KeqAK.*x(12)+power(power(SUMAXP,2)-2.*SUMAXP.*x(12)+8.*KeqAK.*SUMAXP.*x(12)+power(x(12),2)-4.*KeqAK.*power(x(12),2),0.5))./((2-8.*KeqAK).*KmPFKATP.*KmPFKF6P),2)));

% r7
VmALD     =   322.258 ;   
KeqTPI    =   0.045 ;     
KeqALD    =   0.069 ;     
KmALDF16P =   0.3   ;     
KmALDDHAP =   2.4 ;       
KmALDGAP  =   2   ;       
KmALDGAPi =   10  ;
r7 = VmALD.*(x(4)-KeqTPI*power(x(5),2)./(KeqALD*power(1+KeqTPI,2)))./(KmALDF16P*(1+x(4)./KmALDF16P+x(5)./((1+KeqTPI).*KmALDDHAP)+KeqTPI*x(5)./((1+KeqTPI)*KmALDGAP)+KeqTPI*x(4).*x(5)./((1+KeqTPI)*KmALDF16P*KmALDGAPi)+KeqTPI*power(x(5),2)./(power(1+KeqTPI,2)*KmALDDHAP*KmALDGAP)));

% r8
VmG3PDH   =     70.15 ;    
KeqG3PDH  =     4300  ;    
KeqTPI    =     0.045 ;    
KmG3PDHDHAP =   0.4   ;    
KmG3PDHNADH =   0.023 ;    
KmG3PDHNAD  =   0.93  ;    
KmG3PDHGLY  =   1     ;
r8 = VmG3PDH.*(-(GLY.*CC14./KeqG3PDH)+x(13).*x(5)./(1+KeqTPI))./(KmG3PDHDHAP*KmG3PDHNADH*(1+CC14./KmG3PDHNAD+x(13)./KmG3PDHNADH).*(1+GLY./KmG3PDHGLY+x(5)./((1+KeqTPI).*KmG3PDHDHAP)));

% r9
VmGAPDHr    =   6549.68;    
KmGAPDHBPG  =   0.0098 ;    
KmGAPDHNADH =   0.06   ;    
KeqTPI      =   0.045  ;    
VmGAPDHf    =   1184.52;    
KmGAPDHGAP  =   0.21   ;    
KmGAPDHNAD  =   0.09   ;
r9 = (-(VmGAPDHr.*x(6).*x(13)./(KmGAPDHBPG*KmGAPDHNADH))+KeqTPI*VmGAPDHf.*CC14.*x(5)./((1+KeqTPI)*KmGAPDHGAP*KmGAPDHNAD))./((1+CC14./KmGAPDHNAD+x(13)./KmGAPDHNADH).*(1+x(6)./KmGAPDHBPG+KeqTPI*x(5)./((1+KeqTPI)*KmGAPDHGAP)));

% r10
VmPGK    =   1306.45   ; 
KeqPGK   =   3200    ;   
SUMAXP   =   4.1     ;   
KeqAK    =   0.45    ;   
KmPGKATP =   0.3     ;   
KmPGKP3G =   0.53    ;   
KmPGKADP =   0.2     ;   
KmPGKBPG =   0.003   ;
r10 = VmPGK*(KeqPGK*x(6).*(SUMAXP-power(power(SUMAXP,2)-2*SUMAXP*x(12)+8*KeqAK*SUMAXP*x(12)+power(x(12),2)-4*KeqAK*power(x(12),2),0.5))./(1-4*KeqAK)-(-SUMAXP+x(12)-4*KeqAK*x(12)+power(power(SUMAXP,2)-2*SUMAXP*x(12)+8*KeqAK*SUMAXP*x(12)+power(x(12),2)-4*KeqAK*power(x(12),2),0.5)).*x(7)./(2-8*KeqAK))./(KmPGKATP*KmPGKP3G*(1+(SUMAXP-power(power(SUMAXP,2)-2*SUMAXP*x(12)+8*KeqAK*SUMAXP*x(12)+power(x(12),2)-4*KeqAK*power(x(12),2),0.5))./((1-4*KeqAK)*KmPGKADP)+(-SUMAXP+x(12)-4*KeqAK*x(12)+power(power(SUMAXP,2)-2*SUMAXP*x(12)+8*KeqAK*SUMAXP*x(12)+power(x(12),2)-4*KeqAK*power(x(12),2),0.5))./((2-8*KeqAK)*KmPGKATP)).*(1+x(6)./KmPGKBPG+x(7)./KmPGKP3G));

% r11
VmPGM    =   2525.81 ;   
KmPGMP3G =   1.2   ;     
KeqPGM   =   0.19  ;     
KmPGMP2G =   0.08  ;
r11 = VmPGM./KmPGMP3G*(x(7)-x(8)./KeqPGM)./(1+x(7)./KmPGMP3G+x(8)./KmPGMP2G);

% r12
VmENO    =   365.806 ;   
KmENOP2G =   0.04   ;    
KeqENO   =   6.7    ;    
KmENOPEP =   0.5    ;
r12 = VmENO/KmENOP2G*(x(8)-x(9)./KeqENO)./(1+x(8)./KmENOP2G+x(9)./KmENOPEP);

% r13
VmPYK    =   1088.71;    
KmPYKPEP =   0.14  ;     
KmPYKADP =   0.53  ;     
SUMAXP   =   4.1   ;     
KeqAK    =   0.45  ;     
KeqPYK   =   6500  ;     
KmPYKPYR =   21    ;     
KmPYKATP =   1.5   ;
r13 = VmPYK/(KmPYKPEP*KmPYKADP).*(x(9).*(SUMAXP-power(power(x(12),2)-4*KeqAK.*power(x(12),2)-2*x(12)*SUMAXP+8*KeqAK*x(12)*SUMAXP+power(SUMAXP,2),0.5))./(1-4*KeqAK)-x(10).*((x(12)-4*KeqAK*x(12)-SUMAXP+power(power(x(12),2)-4*KeqAK*power(x(12),2)-2*x(12)*SUMAXP+8*KeqAK*x(12)*SUMAXP+power(SUMAXP,2),0.5))./(2-8*KeqAK))./KeqPYK)./((1+x(9)./KmPYKPEP+x(10)./KmPYKPYR).*(1+(x(12)-4*KeqAK*x(12)-SUMAXP+power(power(x(12),2)-4*KeqAK*power(x(12),2)-2*x(12)*SUMAXP+8*KeqAK*x(12)*SUMAXP+power(SUMAXP,2),0.5))./(2-8*KeqAK)./KmPYKATP+(SUMAXP-power(power(x(12),2)-4*KeqAK*power(x(12),2)-2*x(12)*SUMAXP+8*KeqAK*x(12)*SUMAXP+power(SUMAXP,2),0.5))./(1-4*KeqAK)./KmPYKADP));

% r14
VmPDC    =   174.194    ;
nPDC     =   1.9    ;    
KmPDCPYR =   4.33   ;    
r14 = VmPDC.*(power(x(10),nPDC)./power(KmPDCPYR,nPDC))./(1+power(x(10),nPDC)./power(KmPDCPYR,nPDC));

% r15
VmADH   =     810  ;       
KiADHNAD=     0.92 ;       
KmADHETOH =   17    ;      
KeqADH    =   6.9e-005  ;  
KmADHNAD  =   0.17   ;     
KmADHNADH =   0.11   ;     
KiADHNADH =   0.031  ;     
KmADHACE  =   1.11   ;     
KiADHACE  =   1.1    ;     
KiADHETOH =   90   ;       
r15 = -(VmADH./(KiADHNAD*KmADHETOH).*(CC14.*ETOH-x(13).*x(11)./KeqADH)./(1+CC14./KiADHNAD+KmADHNAD*ETOH./(KiADHNAD*KmADHETOH)+KmADHNADH*x(11)./(KiADHNADH*KmADHACE)+x(13)./KiADHNADH+CC14.*ETOH./(KiADHNAD*KmADHETOH)+KmADHNADH.*CC14.*x(11)./(KiADHNAD*KiADHNADH*KmADHACE)+KmADHNAD*ETOH.*x(13)./(KiADHNAD*KmADHETOH*KiADHNADH)+x(13).*x(11)./(KiADHNADH*KmADHACE)+CC14.*ETOH.*x(11)./(KiADHNAD*KmADHETOH*KiADHACE)+ETOH.*x(13).*x(11)./(KiADHETOH*KiADHNADH*KmADHACE)));

% r16
KSUCC   = 21.4     ;
r16 = KSUCC.*x(11);

% r17
KATPASE  =  39.5   ;   
KeqAK    =  0.45   ;   
SUMAXP   =  4.1  ;
r17 = KATPASE.*((x(12)-4*KeqAK*x(12)-SUMAXP+power(power(x(12),2)-4*KeqAK*power(x(12),2)-2*x(12)*SUMAXP+8*KeqAK*x(12)*SUMAXP+power(SUMAXP,2),0.5))./(2-8*KeqAK));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xdot(1) = r1 - r2;  %GLCi   % the Ito SDE xdot w.r.t. X1
xdot(2) = r2 - r3 - r4 - 2*r5; %G6P    % the Ito SDE xdot w.r.t. x(2)
xdot(3) = r3 - r6; %F6P   % the Ito SDE xdot w.r.t. x(2)
xdot(4) = r6 - r7;  % F16P  % the Ito SDE xdot w.r.t. x(2)
xdot(5) = 2*r7 - r8 - r9;  % TrioP
xdot(6) = r9- r10 ;  % BPG
xdot(7) = r10 - r11;  % P3G
xdot(8) = r11 - r12;  % P2G
xdot(9) = r12 - r13;  % PEP
xdot(10) = r13 - r14;  % PYR
xdot(11) = r14 - r15 - 2*r16;  % ACAL
xdot(12) = -r2 -r4 -r5 -r6 +r10 +r13 -r17;  % P
xdot(13) = -r8 + r9 -r15 +3*r16;  % NADH

xdot = xdot(:);













