clear all
addpath models_library
tic

x0 = [ 0.09874   1.034  0.1129    0.6020   0.7776  0.0003297   0.3565  0.04485  0.07363 8.523  0.1701  6.309   0.0444]; % s.state

sigma = 0.1*ones(1,13); % the SDE structural parameter sigma.
                          % Set this values to zero to simulate
                          % deterministic case.

problem = 'Mteusink'; % the name of the experiment
% The corresponding m file is under models_library folder.
                   
t0 = 0; % the time-span initial value
Tf = 3; % the time-span last value
h = 1e-6; % the stepsize for the numerical integration
numsim = 1000; % the number of trajectories
sdetype = 'Ito'; % must be Ito when using the EM scheme
randseed = ceil(100000*rand); % this is the seed for the generation of pseudo-random Wiener increments
                            % set to a constant value to get reproducible results.
integrator = 'Mil'; % must be EM (Euler-Maruyama, only for Ito SDEs) or Mil
model = 'Mteusink_sdefile'; 
numdepvars = 13; % the dimension of the SDE (NO OF METABOLITES)
yesdata = 0; % can be 0 (no raw data available) or 1 (data available)
% store the simulated trajectories into xhat
xhat = SDE_milstein_IC_jb([x0,sigma],problem,[t0:h:Tf],numdepvars,numsim,sdetype,...
randseed);


toc

Cf=reshape(xhat,numdepvars,numsim);
Cf1(:,:,jjj) = Cf'; % the end-point values of all numsim times simulations.


